; You'll need FASM (http://flatassembler.net/) to compile this program.
format PE GUI 4.0
entry start

include 'win32ax.inc'

ID_BLOOD_OFF   = 201
ID_BLOOD_RED   = 202
ID_BLOOD_GREEN = 203
ID_BLOOD_RAZOR = 204

SZ_DATA_LEN = 6

macro CompareBlood _blood_var
{
  inc eax
  mov esi, _blood_now
  mov edi, _blood_var
  mov ecx, SZ_DATA_LEN
  cld
  rep cmpsb
}

macro MoveBlood _blood_var
{
  push ecx
  push esi
  push edi
  mov esi, _blood_var
  mov edi, _blood_now
  mov ecx, SZ_DATA_LEN
  cld
  rep movsb
  pop edi
  pop esi
  pop ecx
}

section '.text' code readable executable

  start:
; ---------------------------------------------
; Windows XP bugfix
; DialogBoxParam failed (return code -1) if application with manifest don't have COMCTL32.DLL loaded
; actually we don't need to call InitCommonControls, only COMCTL32.DLL must be loaded,
; but FASM removes dll from import with unusing functions
        invoke InitCommonControls
; ---------------------------------------------
        invoke SetFileAttributes, _blood_fnm, FILE_ATTRIBUTE_ARCHIVE
        invoke CreateFile, _blood_fnm, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
        cmp eax, INVALID_HANDLE_VALUE
        jz @skip_open
           mov [_handle], eax
           invoke SetFilePointer, [_handle], [_blood_pos], 0, FILE_BEGIN
           invoke ReadFile, [_handle], _blood_now, SZ_DATA_LEN, flags, 0

           invoke SetFilePointer, [_handle], [_blood_rfo], 0, FILE_BEGIN
           invoke ReadFile, [_handle], _blood_rzr, 1, flags, 0

           invoke CloseHandle, [_handle]
        @skip_open:

        xor     eax, eax
        CompareBlood    _blood_off ; eax = 1 - off
        jz      @CBQuit
        CompareBlood    _blood_red ; eax = 2 - red
        jz      @CBQuit
        CompareBlood    _blood_grn ; eax = 3 - green
        jz      @CBQuit
        xor     eax, eax ; 0 - error / unknown file
        @CBQuit:
        test    eax, eax
        jz      @err_exit ; error - must exit
        mov     [flags], eax
        add     [flags], 200
; -----------------------------------------------------
        invoke  GetModuleHandle,0
        invoke  DialogBoxParam,eax,37,HWND_DESKTOP,DialogProc,0
        test    eax, eax
        jz      @exit
; -----------------------------------------------------
        invoke SetFileAttributes, _blood_fnm, FILE_ATTRIBUTE_ARCHIVE
        invoke CreateFile, _blood_fnm, GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
        cmp eax, INVALID_HANDLE_VALUE
        jz @skip_fix
           mov [_handle], eax
           invoke GetFileTime, [_handle], _t1, _t2, _t3

           invoke SetFilePointer, [_handle], [_blood_pos], 0, FILE_BEGIN
           invoke WriteFile, [_handle], _blood_now, SZ_DATA_LEN, flags, 0

           invoke SetFilePointer, [_handle], [_blood_rfo], 0, FILE_BEGIN
           invoke WriteFile, [_handle], _blood_rzr, 1, flags, 0

           invoke SetFileTime, [_handle], _t1, _t2, _t3
           invoke CloseHandle, [_handle]
        @skip_fix:
        jmp     @exit
  @err_exit:
        invoke  MessageBox, HWND_DESKTOP, _err_msg, 0, MB_ICONERROR
  @exit:
        invoke  ExitProcess,0

proc DialogProc hwnddlg,msg,wparam,lparam
        push    ebx esi edi
        cmp     [msg],WM_INITDIALOG
        je      .wminitdialog
        cmp     [msg],WM_COMMAND
        je      .wmcommand
        cmp     [msg],WM_CLOSE
        je      .wmclose
        xor     eax,eax
        jmp     .finish
  .wminitdialog:
        invoke  GetModuleHandle,0
        invoke  LoadIcon,eax,17
        push    eax
        invoke  SendMessage,[hwnddlg],WM_SETICON,ICON_BIG,eax
        pop     eax
        invoke  SendMessage,[hwnddlg],WM_SETICON,ICON_SMALL,eax
        invoke  CheckRadioButton,[hwnddlg],ID_BLOOD_OFF,ID_BLOOD_GREEN,[flags]
        invoke  CheckDlgButton,[hwnddlg],ID_BLOOD_RAZOR,[_blood_rzr]
        jmp     .processed
  .wmcommand:
        cmp     [wparam],BN_CLICKED shl 16 + IDCANCEL
        je      .wmclose
        cmp     [wparam],BN_CLICKED shl 16 + IDOK
        jne     .processed
        mov     [flags],MB_OK
        invoke  IsDlgButtonChecked,[hwnddlg],ID_BLOOD_OFF
        cmp     eax,BST_CHECKED
        jne     .blood_red
        MoveBlood       _blood_off
      .blood_red:
        invoke  IsDlgButtonChecked,[hwnddlg],ID_BLOOD_RED
        cmp     eax,BST_CHECKED
        jne     .blood_green
        MoveBlood       _blood_red
      .blood_green:
        invoke  IsDlgButtonChecked,[hwnddlg],ID_BLOOD_GREEN
        cmp     eax,BST_CHECKED
        jne     .blood_razor
        MoveBlood       _blood_grn
      .blood_razor:
        mov     [_blood_rzr], 0
        invoke  IsDlgButtonChecked,[hwnddlg],ID_BLOOD_RAZOR
        cmp     eax,BST_CHECKED
        jne     .skip_all
        mov     [_blood_rzr], 1
      .skip_all:
        invoke  EndDialog,[hwnddlg],1
        jmp     .processed
  .wmclose:
        invoke  EndDialog,[hwnddlg],0
  .processed:
        mov     eax,1
  .finish:
        pop     edi esi ebx
        ret
endp

section '.bss' readable writeable
  _err_msg db 'Can''t open or invalid input file:', 10, 10
  ; executable filename
  _blood_fnm db 'Turok2German.exe',0
  ; blood code position
  _blood_pos dd 0005CE23h
  ; mov bl, [005DAE37] // 0 - original code
  _blood_off db 08Ah,01Dh,037h,0AEh,05Dh,000h
  ; mov ebx, 1; nop // 1 - red blood
  _blood_red db 0BBh,001h,000h,000h,000h,090h
  ; mov ebx, 2; nop // 2 - green blood
  _blood_grn db 0BBh,002h,000h,000h,000h,090h
  ; blood razor offset
  _blood_rfo dd 00027B8Fh
  ; blood on razor blade
  _blood_rzr dd ?
  ; buffer to read current state
  _blood_now db SZ_DATA_LEN dup(?)
  ; file handle
  _handle dd ?
  flags dd ?
  ; file datatime
  _t1 dq ?
  _t2 dq ?
  _t3 dq ?

section '.idata' import data readable

  library kernel,'KERNEL32.DLL',\
          user,'USER32.DLL',\
          comctl,'COMCTL32.DLL'

  import kernel,\
         GetModuleHandle,'GetModuleHandleA',\
         SetFileAttributes,'SetFileAttributesA',\
         CreateFile,'CreateFileA',\
         SetFilePointer,'SetFilePointer',\
         ReadFile,'ReadFile',\
         WriteFile,'WriteFile',\
         GetFileTime,'GetFileTime',\
         SetFileTime,'SetFileTime',\
         CloseHandle,'CloseHandle',\
         ExitProcess,'ExitProcess'

  import user,\
         DialogBoxParam,'DialogBoxParamA',\
         CheckRadioButton,'CheckRadioButton',\
         CheckDlgButton,'CheckDlgButton',\
         GetDlgItemText,'GetDlgItemTextA',\
         IsDlgButtonChecked,'IsDlgButtonChecked',\
         MessageBox,'MessageBoxA',\
         LoadIcon,'LoadIconA',\
         SendMessage,'SendMessageA',\
         EndDialog,'EndDialog'

  import comctl,\
         InitCommonControls,'InitCommonControls'

section '.rsrc' resource data readable

  directory RT_DIALOG,dialogs,\
            RT_ICON,icons,\
            RT_GROUP_ICON,group_icons,\
            RT_MANIFEST,manifests

  resource dialogs,37,LANG_ENGLISH+SUBLANG_DEFAULT,demonstration
  dialog demonstration,'Turok 2: Seed of Evil - German blood fix v1.1',70,70,200,95,WS_CAPTION+WS_POPUP+WS_SYSMENU+DS_MODALFRAME+DS_CENTER
    dialogitem 'BUTTON','Blood color:',-1,00,0,70,60,WS_VISIBLE+BS_GROUPBOX
    dialogitem 'BUTTON','&Off',ID_BLOOD_OFF,10,12,55,13,WS_VISIBLE+BS_AUTORADIOBUTTON+WS_TABSTOP+WS_GROUP
    dialogitem 'BUTTON','&Red',ID_BLOOD_RED,10,25,55,13,WS_VISIBLE+BS_AUTORADIOBUTTON
    dialogitem 'BUTTON','&Green',ID_BLOOD_GREEN,10,38,55,13,WS_VISIBLE+BS_AUTORADIOBUTTON
    dialogitem 'BUTTON','&Show blood on Razor Blade',ID_BLOOD_RAZOR,75,10,102,13,WS_VISIBLE+WS_TABSTOP+BS_AUTOCHECKBOX
    dialogitem 'STATIC',<169,' -=CHE@TER=- 2012',10,'http://CTPAX-CHEATER.losthost.org/'>,-1,75,45,130,30,WS_VISIBLE
    dialogitem 'BUTTON','OK',IDOK,55,70,45,15,WS_VISIBLE+WS_TABSTOP+BS_DEFPUSHBUTTON
    dialogitem 'BUTTON','C&ancel',IDCANCEL,105,70,45,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
  enddialog

  resource icons,2,LANG_NEUTRAL,icon_data
  resource group_icons,17,LANG_NEUTRAL,main_icon
  icon main_icon,icon_data,'blood.ico'

  resource manifests,1,LANG_NEUTRAL,manifest
  resdata manifest
    file 'Manifest.xml'
  endres
